Bug 1018626 - Review Request: libfaketime - Manipulate system time per process for testing purposes
Review Request: libfaketime - Manipulate system time per process for testing ...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Patrick Uiterwijk
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-10-13 19:15 EDT by Paul Wouters
Modified: 2014-11-18 03:09 EST (History)
5 users (show)

See Also:
Fixed In Version: libfaketime-0.9.6-1.el7
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-11-06 21:32:49 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
puiterwijk: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Paul Wouters 2013-10-13 19:15:52 EDT
Spec URL: ftp://ftp.nohats.ca/libfaketime/libfaketime.spec
SRPM URL: ftp://ftp.nohats.ca/libfaketime/libfaketime-0.9.5-1.fc19.src.rpm
Description: libfaketime intercepts various system calls which programs use to
retrieve the current date and time. It can then report faked dates and
times (as specified by you, the user) to these programs. This means you
can modify the system time a program sees without having to change the
time system- wide.

Fedora Account System Username: pwouters
Comment 1 Patrick Uiterwijk 2013-10-13 20:36:37 EDT
Two primary notices:

1. You don't need the %ifarch  x86_64, %{_lib} (and as a result %{_libdir}) are already lib on i686, and lib64 on x86_64.

2. This package compiles on x86_64 but not on i686??? Source: http://koji.fedoraproject.org/koji/taskinfo?taskID=6056725
Comment 3 Paul Wouters 2013-10-13 20:49:20 EDT
odd

+ CFLAGS='-O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector --param=ssp-buffer-size=4 -grecord-gcc-switches  -m32 -march=x86-64 -mtune=generic -mfpmath=sse -fasynchronous-unwind-tables -Wno-strict-aliasing'
+ make -j16 PREFIX=/usr LIBDIRNAME=/lib/faketime all
cc -o libfaketime.o -c -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector --param=ssp-buffer-size=4 -grecord-gcc-switches  -m32 -march=x86-64 -mtune=generic -mfpmath=sse -fasynchronous-unwind-tables -Wno-strict-aliasing -std=gnu99 -Wall -Wextra -Werror -DFAKE_STAT -DFAKE_SLEEP -DFAKE_TIMERS -DFAKE_INTERNAL_CALLS -fPIC -DPREFIX='"'/usr'"' -DLIBDIRNAME='"'/lib/faketime'"'  libfaketime.c
cc -o libfaketimeMT.o -c -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector --param=ssp-buffer-size=4 -grecord-gcc-switches  -m32 -march=x86-64 -mtune=generic -mfpmath=sse -fasynchronous-unwind-tables -Wno-strict-aliasing -std=gnu99 -Wall -Wextra -Werror -DFAKE_STAT -DFAKE_SLEEP -DFAKE_TIMERS -DFAKE_INTERNAL_CALLS -fPIC -DPREFIX='"'/usr'"' -DLIBDIRNAME='"'/lib/faketime'"'  libfaketime.c
cc -o faketime -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector --param=ssp-buffer-size=4 -grecord-gcc-switches  -m32 -march=x86-64 -mtune=generic -mfpmath=sse -fasynchronous-unwind-tables -Wno-strict-aliasing -std=gnu99 -Wall -Wextra -Werror -DFAKE_STAT -DFAKE_SLEEP -DFAKE_TIMERS -DFAKE_INTERNAL_CALLS -fPIC -DPREFIX='"'/usr'"' -DLIBDIRNAME='"'/lib/faketime'"'  faketime.c -Wl,--version-script=libfaketime.map -lrt -ldl -lm -lpthread -lrt
cc -o libfaketime.so.1 -Wl,-soname,libfaketime.so.1 -Wl,--version-script=libfaketime.map -lrt -shared libfaketime.o -ldl -lm -lpthread -lrt
cc -o libfaketimeMT.so.1 -Wl,-soname,libfaketimeMT.so.1 -Wl,--version-script=libfaketime.map -lrt -shared libfaketimeMT.o -ldl -lm -lpthread -lrt
libfaketime.o: In function `ft_cleanup':
/builddir/build/BUILD/libfaketime-0.9.5/src/libfaketime.c:1275: multiple definition of `timer_gettime'
/builddir/build/BUILD/libfaketime-0.9.5/src/libfaketime.c:1275: multiple definition of `timer_settime'
collect2: error: ld returned 1 exit status
make: *** [libfaketime.so.1] Error 1
make: *** Waiting for unfinished jobs....
libfaketimeMT.o: In function `ft_cleanup':
/builddir/build/BUILD/libfaketime-0.9.5/src/libfaketime.c:1275: multiple definition of `timer_gettime'
/builddir/build/BUILD/libfaketime-0.9.5/src/libfaketime.c:1275: multiple definition of `timer_settime'
collect2: error: ld returned 1 exit status
make: *** [libfaketimeMT.so.1] Error 1
RPM build errors:

I don't see that on x86_64. Will investigate
Comment 4 Susi Lehtola 2013-10-14 13:39:30 EDT
This is a duplicate of bug #1016508.

*** This bug has been marked as a duplicate of bug 1016508 ***
Comment 5 Paul Wouters 2013-10-15 16:42:01 EDT
Spec URL: ftp://ftp.nohats.ca/libfaketime/libfaketime.spec
SRPM URL: ftp://ftp.nohats.ca/libfaketime/libfaketime-0.9.5-4.fc19.src.rpm


* Tue Oct 15 2013 Paul Wouters <pwouters@redhat.com> - 0.9.5-4
- Infinite recursion patch is still needed, make test causes
  segfaults otherwise.
Comment 6 Patrick Uiterwijk 2013-10-17 08:32:19 EDT
As this bug has been reopened, I will review this again.
Great to see that people work together! :-)
Comment 7 Patrick Uiterwijk 2013-10-18 11:06:18 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

===== ISSUES ========
1. Please add %{_libdir}/faketime, as that directory is not owned by any other package
2. Please replace $RPM_OPT_FLAGS with %{optflags} to get consistent macro usage
3. Please add a comment to the patch linking to the upsteam bug report
4. Why do you remove %{_docdir}, and not just package it in libfaketime-doc?
5. unstripped-binary-or-object /usr/lib64/faketime/libfaketime.so.1: You should strip the binaries


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
     Note: koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=6072609
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: Package requires other packages for directories it uses.
[!]: Package must own all directories that it creates.
     Issue: Please add %{_libdir}/faketime, as that directory is not owned by any other package
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[!]: Package consistently uses macros (instead of hard-coded directory names).
     Issue: Please replace $RPM_OPT_FLAGS with %{optflags} to get consistent macro usage
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[x]: Package complies to the Packaging Guidelines
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
     Note: Used koji. Check MUST items for link
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: Patches link to upstream bugs/comments/lists or are otherwise justified.
     Issue: Please link to the upstream bug report
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: libfaketime-0.9.5-4.fc21.x86_64.rpm
          libfaketime-0.9.5-4.fc19.src.rpm
libfaketime.x86_64: W: unstripped-binary-or-object /usr/lib64/faketime/libfaketime.so.1
libfaketime.x86_64: W: unstripped-binary-or-object /usr/lib64/faketime/libfaketimeMT.so.1
2 packages and 0 specfiles checked; 0 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint libfaketime
libfaketime.x86_64: W: unstripped-binary-or-object /usr/lib64/faketime/libfaketime.so.1
libfaketime.x86_64: W: unstripped-binary-or-object /usr/lib64/faketime/libfaketimeMT.so.1
1 packages and 0 specfiles checked; 0 errors, 2 warnings.
# echo 'rpmlint-done:'



Requires
--------
libfaketime (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    librt.so.1()(64bit)
    rtld(GNU_HASH)



Provides
--------
libfaketime:
    libfaketime
    libfaketime(x86-64)



Source checksums
----------------
http://www.code-wizards.com/projects/libfaketime/libfaketime-0.9.5.tar.gz :
  CHECKSUM(SHA256) this package     : 5e07678d440d632bef012068ca58825402da5ad25954513e785717cc539c213d
  CHECKSUM(SHA256) upstream package : 5e07678d440d632bef012068ca58825402da5ad25954513e785717cc539c213d


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -p -n libfaketime
Buildroot used: fedora-19-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 8 Patrick Uiterwijk 2013-12-04 06:55:36 EST
Is there any progress on this?
Comment 9 Paul Wouters 2014-01-28 23:22:22 EST
Spec URL: ftp://ftp.nohats.ca/libfaketime/libfaketime.spec
SRPM URL: ftp://ftp.nohats.ca/libfaketime/libfaketime-0.9.5-2.fc20.src.rpm

changelog:

* Wed Jan 29 2014 Paul Wouters <pwouters@redhat.com> - 0.9.5-2
- Own the faketime directory
- Use optflags instead of RPM_OPT_FLAGS
- Ensure libraries are stripped
- Place libraries in non-system path. Should only be used explicitly

I deleted the doc files because those are identical to what we include using %doc, but rpm gives warnings if the files are there already and the %doc macro would overwrite the existing (identical) files.

It's just a few readme like files, not worth a separate -doc package.
Comment 10 Patrick Uiterwijk 2014-03-03 05:19:47 EST
Why are you stating the directory and the files in it seperately like this?
%dir %attr(0755,root,root) %_libdir/faketime
%attr(0755,root,root) %{_libdir}/faketime/%{name}*.so.*

Just this would accomplish the same, and be much clearer:
%attr(0755,root,root) %{_libdir}/faketime


Please fix this before pushing to the repos.

This package is APPROVED
Comment 11 Christopher Meng 2014-03-03 07:31:02 EST
Do we need %attr(0755,root,root) ?

Please chmod +x the libraries in %install section if their permissions are incorrect.
Comment 12 Paul Wouters 2014-03-26 12:32:26 EDT
New Package SCM Request
=======================
Package Name: libfaketime
Short Description: Manipulate system time per process for testing purposes
Owners: pwouters
Branches: f20 el6 el7
InitialCC:
Comment 13 Paul Wouters 2014-03-26 12:33:26 EDT
Christopher: I prefer using attr as that makes it independent of the build system settings or the upstream make install permissions. It's a guarantee the permissions will be correct.
Comment 14 Gwyn Ciesla 2014-03-26 12:35:46 EDT
Git done (by process-git-requests).
Comment 15 Niranjan Mallapadi Raghavender 2014-08-28 11:10:21 EDT
Any timeline , as to when  this package be made available on Fedora 20, RHEL7, (Or RHEL6 epel ?)
Comment 16 Fedora Update System 2014-10-28 14:46:10 EDT
libfaketime-0.9.6-1.el7 has been submitted as an update for Fedora EPEL 7.
https://admin.fedoraproject.org/updates/libfaketime-0.9.6-1.el7
Comment 17 Fedora Update System 2014-10-28 14:46:37 EDT
libfaketime-0.9.6-1.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/libfaketime-0.9.6-1.fc21
Comment 18 Fedora Update System 2014-10-28 14:47:03 EDT
libfaketime-0.9.6-1.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/libfaketime-0.9.6-1.fc20
Comment 19 Paul Wouters 2014-10-28 14:48:10 EDT
seems that el6 is failing "make check", so that one needs a little more work.
Comment 20 Fedora Update System 2014-10-29 07:04:52 EDT
libfaketime-0.9.6-1.fc20 has been pushed to the Fedora 20 testing repository.
Comment 21 Fedora Update System 2014-11-06 21:32:49 EST
libfaketime-0.9.6-1.fc20 has been pushed to the Fedora 20 stable repository.
Comment 22 Fedora Update System 2014-11-10 01:29:25 EST
libfaketime-0.9.6-1.fc21 has been pushed to the Fedora 21 stable repository.
Comment 23 Fedora Update System 2014-11-18 03:09:01 EST
libfaketime-0.9.6-1.el7 has been pushed to the Fedora EPEL 7 stable repository.

Note You need to log in before you can comment on or make changes to this bug.